#!/bin/sh

# Author: Artur Szostak
# Email:  artursz@iafrica.com  |  artur@alice.phy.uct.ac.za

# This script tries to find the PSI module source code and 
# prints the top directory to the source.

# Search for a directory containing a specific substring in a specific
# subdirectory. The following are the subdirectories to search in and
# the substrings to look for.
DIRLIST=". .. ../.. /usr/src /usr/local"
NAMELIST="PSI"

for DIR in $DIRLIST ; do
	if test ! -d $DIR ; then
		continue
	fi
	for NAME in $NAMELIST ; do
		FILES=`ls -1 -t $DIR | grep -i $NAME`
		for FILE in $FILES ; do
			if test -d $DIR/$FILE ; then
				echo `cd $DIR/$FILE; pwd`
				exit 0
			fi
		done
	done
done

# So we could not find a predefined directory so lets try use locate
# to find a file called psi.h in an include subdirectory. Then
# search through the found list for the newest directory.

FILELIST=`locate include/psi.h`

for FILE in $FILELIST ; do
	# Strip the filename and 'include' dir name:
	DIR=`echo $FILE | sed 's/\(^.*\)\/.*/\1/' | sed 's/\(^.*\)\/.*/\1/'`
	if test ! -d $DIR ; then
		continue
	fi
	if test -z $TOPDIR ; then
		TOPDIR=$DIR;
	elif test $DIR -nt $TOPDIR ; then 
		TOPDIR=$DIR;
	fi
done

if test ! -z $TOPDIR ; then
	echo $TOPDIR
	exit 0
fi

# Could not find source.
exit 1

