/*******************************************************************************

  Author: Artur Szostak
  Email:  artur@alice.phy.uct.ac.za  |  artursz@iafrica.com
  
  Some useful routines for fetching the IRQ line for a PCI device using the PSI
  module. This is particularly useful with the 'irqsignal' module which requires
  the user to give a particular IRQ line to listen to.

********************************************************************************/

#ifndef FETCH_IRQ_LINE_ROUTINES_H
#define FETCH_IRQ_LINE_ROUTINES_H

#include "psi.h"

PSI_Status FetchIRQLineByVendor(
		const unsigned short vendID, const unsigned short devID, const unsigned int card,
		unsigned char* irqline
	);


PSI_Status FetchIRQLineByBus(
		const unsigned short bus, const unsigned short dev, const unsigned short func,
		unsigned char* irqline
	);

#endif // FETCH_IRQ_LINE_ROUTINES_H
