
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

PACKAGE HLT_RORC_definitions IS

-- The following constants represent the register address layour on
-- BAR0 of the HLT-RORC card.

  -- CSR Block
  CONSTANT ad_csr_global        : integer := 24;
  CONSTANT ad_csr_reset         : integer := 28;
  CONSTANT ad_csr_fclear        : integer := 56;
  
  -- Pattern Generator
  CONSTANT ad_patgen_evlen_reg  : integer := 32;
  CONSTANT ad_patgen_csr_reg    : integer := 36;
  CONSTANT ad_patgen_start_reg  : integer := 40;

  -- DMA
  CONSTANT ad_dma_writeptr      : integer := 0;
  CONSTANT ad_dma_bufflen       : integer := 4;
  CONSTANT ad_dma_readptr       : integer := 8;
  CONSTANT ad_dma_readptrlen    : integer := 52;
  CONSTANT ad_dma_status_reg    : integer := 12;

  -- Memory Interface
  CONSTANT ad_memif_addr        : integer := 68;
  CONSTANT ad_memif_length      : integer := 72;
  CONSTANT ad_memif_csr         : integer := 76;
  CONSTANT ad_memif_trigger     : integer := 80;
  
  -- Event Monitor
  CONSTANT evmon_counter_addr   : integer := 60;
  
  -- DDL
  CONSTANT ad_commd_reg         : integer := 16;
  CONSTANT ad_ctstw_reg         : integer := 20;
  CONSTANT ad_festw_reg         : integer := 56;
  CONSTANT ad_dtstw_reg         : integer := 60;
  CONSTANT ad_ifstw_reg         : integer := 64;
  
  -- Master Control
  CONSTANT ad_rd_ptr_addr_reg   : integer := 44;
  CONSTANT ad_rd_ptr_reg        : integer := 48;
  CONSTANT ad_dma_error_reg     : integer := 68;
  CONSTANT ad_report_error_reg  : integer := 72;
  CONSTANT ad_read_error_reg    : integer := 76;
  
  -- IRQ Signaler
  CONSTANT ad_irq_status        : integer := 84;
  CONSTANT ad_pulse_length      : integer := 88;
  
END PACKAGE;
    
