--=============================================================================
-- Project    : HLT-RORC
-------------------------------------------------------------------------------
-- File       : indicator.vhd
-- Author     : Heinz Tilsner  <tilsner@kip.uni-heidelberg.de>
-- Company    : 
-- Platform   : 
-------------------------------------------------------------------------------
-- Description:
--
-- Simple counter for flashing LEDs
--
-------------------------------------------------------------------------------
-- Revision list:
-- Date        Version  Author    Description
--
-- 07.07.2004  1.0      tilsner   created
--=============================================================================

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_signed.ALL;

ENTITY indicator IS
  
  PORT (
    clk  : IN  STD_LOGIC;
    rstn : IN  STD_LOGIC;
    leds : OUT STD_LOGIC_VECTOR(3 DOWNTO 0)
  );

END indicator;


ARCHITECTURE structure OF indicator IS

  SIGNAL counter : STD_LOGIC_VECTOR(31 DOWNTO 0);

BEGIN 

  clk_div: PROCESS (clk, rstn)
  BEGIN
    IF (rstn = '0') THEN
      counter <= (OTHERS => '0');
    ELSIF (clk'event AND clk = '1') THEN  -- rising clock edge
      counter <= counter + 1;
    END IF;
  END PROCESS clk_div;

  leds(0) <= counter(24);
  leds(1) <= NOT counter(24);
  leds(2) <= NOT counter(24);
  leds(3) <= counter(24);
  
END structure;
